\documentclass[conference]{IEEEtran}
%\IEEEoverridecommandlockouts
% The preceding line is only needed to identify funding in the first footnote. If that is unneeded, please comment it out.
\usepackage{graphicx,multirow,booktabs,caption, array, listings}
\usepackage{times}  
\usepackage{url}
\usepackage{listings}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{array}
\usepackage{listings}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
\usepackage{amsmath}
\usepackage{color, colortbl}
\usepackage{cite}
\usepackage{siunitx}
\def\BibTeX{{\rm B\kern-.05em{\sc i\kern-.025em b}\kern-.08em
    T\kern-.1667em\lower.7ex\hbox{E}\kern-.125emX}}
\begin{document}

\title{SAIL Based FIB Lookup in a Programmable Pipeline Based Linux Router}

\author{\IEEEauthorblockN{MD Iftakharul Islam, Javed I Khan}
\IEEEauthorblockA{\textit{Kent State University}\\
Kent, Ohio, USA \\
mislam4@kent.edu, javed@cs.kent.edu}
}

\maketitle

\begin{abstract}
This paper presents a programmable pipeline based Linux router. Here Linux kernel works as a control plane and the programmable pipeline works as a data plane. The Forwarding Information Base (FIB) lookup is performed using SAIL algorithm. SAIL consumes very large memory. Here we use \textit{population counting} that reduces the memory consumption of SAIL by up to $80\%$. We have implemented SAIL in Linux kernel. We also have implemented SAIL using Domino programming language. Our implementation shows that a programmable pipeline can execute SAIL at line rate. We have evaluated our implementation with FIBs from real backbone routers. Our experimental results show that SAIL with \textit{population counting} is suitable for implementing both dataplane and control plane of a high-speed router.  	

\end{abstract}

\begin{IEEEkeywords}
LPM; SAIL in Linux Kernel; SAIL in Programmable Pipeline (Domino)
\end{IEEEkeywords}

\section{Introduction}\label{sec:intro}
FIB lookup is a key function of a router. A router needs to extract the destination IP address of an incoming packet and find the outgoing port based on the longest prefix match (LPM) algorithm. For instance, Table \ref{lpm} shows an example FIB table of a router. If the destination IP address of an incoming packet is $169.254.198.1$, then according to the longest prefix match algorithm, the packet should be forwarded to $eth4$. Again if the destination IP address of an incoming packet is $169.254.190.5$, then the packet should be forwarded to $eth3$. The number of routes in the FIB of a backbone router already has exceeded $750K$ and growing rapidly \cite{bgpreport}. A high-speed router needs to perform around $1$ billion FIB lookups per second in order to sustain the line rate \cite{bosshart2013forwarding}. Performing FIB lookup at such a high rate in such a large FIB table is particularly challenging.


Recently several data structures have been proposed that exhibit impressive lookup performance. These include SAIL \cite{yang2014guarantee}, Poptrie \cite{asai2015poptrie} and DXR \cite{zec2012dxr}. Here SAIL outperforms\footnote{We assumed that the FIBs are stored in the on-chip memory. SAIL would perform worse if the FIB is partially stored in the off-chip DRAM.} Poptrie and DXR \cite{asai2015poptrie}. A major drawback of SAIL is its high memory consumption. For instance, it consumes $29.22$ MB for our example FIB table with \num[group-separator={,}]{760195} routes. This often exceeds the on-chip memory of the lookup engine. This paper utilizes  \textit{population counting} \cite{warren2013hacker} which reduces the memory consumption of SAIL by up to $80\%$. For instance, SAIL consumes only $6.09$ MB for the same routing table when \textit{population counting} is used. It is noteworthy that population counting has also been utilized by Poptrie. However, population counting mechanism of Poptrie cannot be applied in SAIL directly (discussed in Section III). SAIL has two variants: SAIL\_L and SAIL\_U. SAIL\_L is optimized for FIB lookup and SAIL\_U is optimized for FIB update.  It is noteworthy that both SAIL\_L and SAIL\_U consumes the same amount of memory. \textit{Population counting} reduces the same amount of memory for both SAIL\_L and SAIL\_U.

\begin {table}[H]
\caption {Routing table (also known as FIB table) } \label{lpm} 
\begin{center}
	\begin{tabular}{ | m{3.6cm} | m{3.6cm} |} 
		\hline Prefix & Outgoing port\\
		\hline $10.18.0.0/22$ & $eth1$\\
		\hline $131.123.252.42/32$ & $eth2$\\
		\hline $169.254.0.0/16$ & $eth3$\\
		\hline $169.254.192.0/18$ & $eth4$\\		
		\hline $192.168.122.0/24$ & $eth5$\\						
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin{figure}[!t]
	\centering
	\includegraphics[width=5cm]{Linux-Router.png}
	\caption{Programmable pipeline based Linux router}\label{Linux-Router}
\end{figure}

We have implemented both SAIL\_L and SAIL\_U in Linux kernel. Our implementation uses \textit{population counting} to reduce their memory consumption. Our implementation enables us to perform FIB lookup, FIB update, FIB delete and FIB flush. It is noteworthy that SAIL on a general purpose CPU cannot sustain the line rate needed for a high-speed router. A high speed router often uses TCAM for implementing FIB lookup. TCAMs however are very power hungry and very limited in capacity \cite{asai2015poptrie}. This is why, commercial router vendors often implement FIB lookup using hardware ASIC \cite{eatherton2004tree}. Hardware ASICs however are not programmable. Recently programmable pipeline  based VLIW processors have emerged as an alternative to a hardware ASIC \cite{sivaraman2016packet, bosshart2013forwarding}. Example of such programmable pipeline based routing/switching chips include Barefoot Tofino \cite{tofino}, Cavium Xplaint \cite{xplaint}, Brodcom Jericho2 \cite{Jericho2} and so on. They allow us to program the router dataplane while achieving very high throughput. For instance, Barefoot Tofino $2$ programmable routing chip can achieve upto $12.8$ Tb/s aggregate throughput. Sivaraman et al. has developed Domino programming language to develop programs for programmable pipelines \cite{sivaraman2016packet}. Figure \ref{Linux-Router} shows a block diagram of a Linux router where the dataplane is implemented by a programmable pipeline. Here Linux kernel is responsible for managing the FIB table. An user space routing application (e.g. Quagga) is responsible for implementing the routing protocols. Here the FIB lookup is performed by the programmable pipeline. The programmable pipeline runs a Domino program that implements the FIB lookup. When the FIB in the kernel is updated by the userspace application, kernel uses the driver to update the SAIL data structures in the programmable pipeline. It is noteworthy that Cumulus Network also uses Linux in their switches \cite{cumulus}. Currently however they only support fixed-function switching chips which are not programmable.

Currently there is no programmable pipeline chip exists that support Domino programming language. We evaluate our Domino based FIB lookup using Domino compiler. Domino compiler enables us to evaluate a Domino program without needing an actual hardware. Domino compiler follows \textit{all-or-nothing approch}. Domino-compiler compiles a domino program if the program can run in a programmable pipeline at line-rate. If the program cannot run at line-rate, the compilation fails. We have implemented SAIL based FIB lookup using Domino programming language. Domino compiler shows that the FIB lookup of SAIL\_U and SAIL\_L require $15$ and $32$ stage pipeline respectively. It also shows that a $1$ GHz VLIW processor can perform $1$ billion FIB lookup using SAIL.

The remaining of the paper proceeds as follows.  Section II presents the related works. In Section III, we describe \textit{population counting}. The Section IV describes the FIB lookup algorithm where \textit{population counting} is used. Section V discusses our implementation. Section VI shows the comparison between SAIL\_U and SAIL\_L in a programmable pipeline. Section VII shows the experimental results. Finally, Section VIII concludes the paper.

\section{Related Works}
CPU based routing table lookup is a long standing research problem. The Lule\aa $\ $ algorithm \cite{degermark1997small} used bitmap to reduce the memory footprint of routing tables. It however does not support incremental update and its lookup process requires many CPU cycles. LC-trie \cite{nilsson1999ip} is a classic algorithm adopted by Linux Kernel. LC-trie combines path compression and level-compression which results in small memory footprint. It however exhibits poor the cache behavior resulting slow lookup speed. Tree Bitmap \cite{eatherton2004tree} is a variant of Lule\aa $\ $ algorithm. It supports incremental update. Tree Bitmap has been adopted by Cisco routers where it is implemented in the application-specific integrated circuit (ASIC). It however also does not perform very well on a general purpose CPU \cite{asai2015poptrie}. DIR-24-8-BASIC \cite{gupta1998routing} has been developed based on the observation that the most of the prefixes in backbone routers are at most $24$ bit long. It maintains an array based on the first $24$ bits of the prefixes. This enables us to lookup most of the IP addresses with just one memory access. DIR-24-8-BASIC has been adopted by DPDK \cite{dpdk}. It however does not perform well when there are prefixes longer than $24$ bit. R\'etv\'ari et al. \cite{retvari2013compressing} proposed a routing table compression algorithm that can compress a routing table with $440$K routes with just $100$-$400$KB. However, small routing table does not always results in good lookup performance. For instance, their routing table lookup consumes $194$ CPU cycles. 

Recently SAIL \cite{yang2014guarantee}, DXR \cite{zec2012dxr} and Poptrie \cite{asai2015poptrie} have been proposed which exhibit impressive lookup performance. DXR represents a routing table with an array of address ranges. It then performs a binary search in the array during the lookup. Here the binary search is the primary bottleneck. Poptrie, on the other hand, divides a routing table into four levels (level $16$, $22$, $28$ and $34$). It also uses population counting to reduce its memory consumption. For instance, a routing table with $500$K routes consumes about $1.1$MB. The lookup process of Poptrie proceeds as follows. At first, it finds the node in level $16$ based on $16$ left most bits of the IP address. In the subsequent steps, it extracts next $6$ bits which leads it to the next level. The lookup ends when it reaches a leaf. This is why, an IPv4 address lookup may require visiting upto $4$ levels. The main bottleneck of Poptrie is that it finds the next-level node based on the next $6$ bits. On the other hand, SAIL finds the next level based on next $8$ bits. SAIL divides a routing table into three levels (level $16$, $24$ and $32$). Thus, SAIL needs to visit one less level than Poptrie which results in a better lookup performance. The main drawback of SAIL is its abnormally high memory consumption which often exceeds on-chip memory. SAIL often needs to access off-chip DRAM which degrades its lookup performance significantly. It is noteworthy that SAIL outperforms Poptrie and DXR when the lookup does not need to access the off-chip DRAM \cite{asai2015poptrie}. This paper presents \textit{population counting} which reduces the memory consumption of SAIL by up to $80\%$. We have implemented SAIL\_L and SAIL\_U in Linux kernel and in a programmable pipeline. We have evaluated our implementation with FIBs from real backbone routers. Although we have not developed the actual VLIW processor, our implementation shows that SAIL can be implemented in a VLIW processor at line rate.

\textbf{Dataplane implementation:} We have implemented SAIL based FIB lookup using Domino programming language. Domino enables us to develop programs for programmable pipelines. Domino has been used to implement various network functions including load balancing \cite{sivaraman2016packet}, router-assisted congestion control \cite{tamimrcp}, network monitoring \cite{narayana2017language} and so on. This paper presents a FIB lookup implementation using Domino. This is the first implementation of a FIB lookup using Domino, to the best of our knowledge.

\begin{figure*}[!t]
	
	\begin{subfigure}[t]{0.2\textwidth}
		\centering
		\includegraphics[width=3.5cm]{routing_table}
		\caption{FIB}\label{routingtable}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.3\textwidth}
		\centering
		\includegraphics[width=5.5cm]{treewopush}
		\caption{Binary tree corresponding to the FIB}\label{treewopush}
	\end{subfigure}%
	~ 	
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=7cm]{tree}
		\caption{Tree constructed by SAIL\_U. Here solid nodes in level $1-2$ are pushed to level $3$; solid nodes in level $4-5$ are pushed to level $6$; solid nodes in level $7-8$ are pushed to level $9$}\label{binarytree}
	\end{subfigure}%
	
	\begin{subfigure}[t]{.66\textwidth}
		\centering
		\includegraphics[width=12cm]{array}
		\caption{$N$ and $C$ array are constructed based on the nodes in level $3, 6$ and $9$ \cite{yang2014guarantee}.}\label{array}
	\end{subfigure}%	 
	~ 	
	\begin{subfigure}[t]{0.34\textwidth}
		\centering
		\includegraphics[width=6cm]{chunk}
		\caption{$C_6$ in Figure \ref{array} is encoded with bitmap and a revised $C_6$ where all the zero entries are eliminated}\label{chunk}
	\end{subfigure}%	
	
	\caption{SAIL\_U with \textit{population counting}}\label{tree}
\end{figure*}


\section{Population Counting} 
This section discusses how \textit{population counting} is used in SAIL. For the sake of completeness, we describe SAIL based FIB lookup at first. We then show how \textit{population counting} is applied in SAIL.

SAIL splits a routing table into three levels: level $16, 24$ and $32$. It then represents those levels with arrays. Here we explain the approach with a simpler example where the routing table is split into three levels: level $3, 6$ and $9$. Figure \ref{routingtable} shows an example FIB. Note that different prefixes in a FIB can have same next-hop. For instance, next-hop $P4$ and $P7$ appeared more than once in the FIB. The FIB is then represented by a binary tree as in Figure \ref{treewopush}. Here all the nodes that have a next hop are called solid nodes. All the nodes that do not have a next hop are called internal nodes. Figure \ref{binarytree} shows the tree constructed by SAIL\_U. SAIL\_U pushes all the solid nodes in level $1-2$ are pushed to level $3$; all the solid nodes in level $4-5$ are pushed to level $6$, and the solid nodes in level $7-8$ are pushed to level $9$. It then represents the level 3, 6 and 9 with nexthop ($N$) and chunk ID array ($C$). Let us use $N_i$ and $C_i$ to represent $N$ and $C$ of level $i$. There can be at most $8 (2^3)$ nodes in level $3$ in Figure \ref{binarytree}. This is why, the size of both $N_3$ and $C_3$ is $8$. $N_3$ and $C_3$ are constructed based on the solid nodes in level $3$ of Figure \ref{binarytree}. $N_3$ contains the next-hops in level 3. On the other hand, $C_3[i]$ indicates if there is a longer prefix than the prefix corresponding $N_3[i]$. $C_3[i] = 0$ indicates that there is no longer prefix exist. Again $C_3[i] > 0$ indicates that there is a longer prefix and the prefix will be found in chunk $C_3[i]$ of level $6$. As the size of a chunk is fixed ($2^3$  in this case), chunk ID enables us to locate the longer prefix in the $N_6$. 

Let us assume that we want to lookup an IP address $11001011b$ in the routing table. It proceeds as follows: It extracts $0$-th to $2$-th bit (three leftmost bit) from the IP address ($6$ in this case). $N_3[6]=P2$ indicates that $P2$ is a potential next-hop for this IP address. However, $C_3[6]=3$ indicates that there might be a longer prefix for the IP address. The longer prefix will be found in chunk 3 of level $6$. SAIL\_U then extracts $3$-th bit to $5$-th bit from the IP address ($2$ in this case). This is why, the longer prefix will be found in $N_6[(3-1)*8+2]$. $N_6[18]=P4$ indicates that $P4$ is the potential next-hop for the IP address. Again $C_6[18]=0$ indicates that there is no longer-prefix exist for this IP address, thus $P4$ is the actual next-hop.

\textbf{Population counting on $C_6$:} $C_6$ in Figure \ref{array} contains the chunk IDs for level $9$. However, most of the entries of the array remain $0$ in practice. Here we use bitmap to eliminate all the zero entries from $C_6$. This is known as population counting which was described in Warren. et al. \cite{warren2013hacker}. Figure \ref{chunk} shows how $C_6$ in Figure \ref{array} is compressed with the aid of a chunk array $CK_6$. Here $CK_6$ contains a bitmap and a start index for each chunk. Bitmap encodes the indices which are not zero in the chunk. Start index on the other hand shows where the chunk starts from in the revised $C_6$ (in Figure \ref{chunk}). For instance, $CK_6[1].bitmap=00110000$ indicates that the chunk $2$ contains two elements and the elements are at the index $4$ and $5$ inside the chunk. Again, $CK_6[1].start\_index=1$ indicates that the chunk $2$ start from $C_6[1]$ in the revised $C_6$ in Figure \ref{chunk}. 

It is noteworthy that Poptrie \cite{asai2015poptrie} also uses population count. It uses a $64$-bit bitmap. Thus, Poptrie can process $6$ bits $(64 = 2^6)$ in every step of the way. Poptrie splits a FIB into four levels: level $16, 22, 28$ and $34$. SAIL, on the other hand, splits a FIB into three levels: $16, 24$ and $32$. This is why, it needs to use a $256$-bit bitmap so that it can process $8$ bits in every step of the way. This is the reason Poptrie cannot be applied directly to SAIL. 

It is noteworthy that although a $256$-bit bitmap may seem to be a trivial change, it however requires extra processing for both FIB lookup and FIB update. FIB lookup uses POPCNT \cite{warren2013hacker} CPU instruction which can process only $64$ bits at a time (on a $64$-bit computer). This is why, we divide the bitmap into four parts. Listing $1$ shows how the bitmap (\textit{chunk} structure) is divided into four parts. Here each part contains a $64$-bit bitmap and an offset to $C$ array for that part. Our SAIL based FIB lookup extracts $8$ bits from the IP address in each step and maps it to a part of the \textit{chunk} structure (instead of the whole chunk itself). This is how, we process $8$ bit in each step of the way while invoking POPCNT only once in each step. The details of the lookup processing and mapping to a part will be discussed in the next section.

\begin{lstlisting}[language=C, caption=Chunk structure]
struct chunk {
u64 bitmap[4]; //256-bit bitmap.
//Index to C24 where the chunk is started.
u64 start_index[4];
};
\end{lstlisting}

\begin {table}[H]
\caption {Data structures used in SAIL} \label{symbols} 
\begin{center}
	\begin{tabular}{ | m{2.5cm} | m{5cm} |}
		\hline $def\_nh$ & Default next-hop (level 0)\\		
		\hline $N_{16}$ & Next-hop array for level $16$\\
		\hline $C_{16}$ & Chunk ID array for level $16$\\
		\hline $N_{24}$ & Next-hop array for level $24$\\
		\hline $CK_{24}$ & Chunk array for level $24$\\		
		\hline $C_{24}$ & Chunk ID array for level $24$ where zero entries are eliminated\\
		\hline $N_{32}$ & Next-hop array for level $32$\\
		\hline $CK\_SZ$ & Chunk Size ($256$ in this case)\\						
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\section{Lookup Algorithm}
This section describes SAIL\_U based FIB lookup where \textit{population counting} is used. An IPv4 address is $32$ bit long. Thus, a prefix can be up to $32$ bit long. SAIL\_U represents a FIB as in Figure \ref{binarytree}. It however pushes all the solid nodes in level $1-15$ to level $16$; the solid nodes in level $17-23$ are pushed to level $24$; and the solid nodes in level $25-31$ are pushed to level $32$. Table \ref{symbols} shows the data structure used by SAIL\_U. It is noteworthy that there is no $C_{32}$. As level $32$ is the last level, it does not need $C_{32}$. Here the size of both $N_{16}$ and $C_{16}$ is $65536$ ($2^{16}$). Again the size of each chunk in level $24$ and $32$ is $256$ ($2^8$). $CK_{24}$ is a chunk array where each chunk consist of a bitmap and start index. As the size of each chunk is $256$, the size of the bitmap needs to be $256$. The chunk structure is shown in Listing 1. Note that instead of having just one \textit{start index} for the whole chunk, we divide the chunk into $4$ parts and save the \textit{start index} for each part. FIB lookup maps an IP address to a part of the chunk during the lookup.

\begin{algorithm}
	\caption{SAIL\_U based FIB Lookup with \textit{population counting}}\label{euclid}
	\begin{flushleft}	
		\textbf{Input}: Destination IP address of the packet - $ip$ \\
		\textbf{Output}: Next-hop - $nexthop$
	\end{flushleft}
	\begin{algorithmic}[1]				
		\Procedure{Lookup}{$ip$}
		\State $nexthop \gets def\_nh$
		\State /*Extract 16 bits from $ip$ */
		\State $idx \gets ip \  >> \ 16$
		\If {$N_{16}[idx] \ > \  0$}
		\State $nexthop \gets N_{16}[idx]$
		\EndIf				
		\If {$C_{16}[idx] \ != \  0$}		
		\State /*Extract bit 17-24 from $ip$ */		
		\State $ck\_off \gets ((ip \ \& \ 65280)>>8)$
		\State $ck\_id \gets C_{16}[idx]$
		\State $idx24 \gets (ck\_id - 1)*CK\_SZ + ck\_off$		
		\Else
		\State {return $nexthop$}	
		\EndIf		
		\If {$N_{24}[idx24] \ > \  0$}
		\State $nexthop \gets N_{24}[idx24]$
		\EndIf
		\State /*Check if there is a chunk in level $32$ for this IP*/
		\State $part\_idx \gets \frac{ck\_off}{64}$
		\State $part\_off \gets ck\_off \ \% \ 64$
		\State $bitmap \gets CK_{24}[ck\_id-1].bitmap[part\_idx]$
		\State $idx \gets CK_{24}[ck\_id-1].start\_index[part\_idx]$
		\If {$bitmap \ \& \ (1ULL << part\_off)$}		
		\State /*Calculate the index to $C_{24}$*/
		\State $c24i \gets idx + BITCOUNT(bitmap, part\_off)$
		\State /*Extract 8 bits from the MSB of $ip$ and calculate index to $N_{32}$*/		
		\State $idx32 \gets (C_{24}[c24i] - 1)*CK\_SZ + ip \  \& \ 255$		
		\Else
		\State {return $nexthop$}	
		\EndIf
		\If {$N_{32}[idx32] \ > \  0$}
		\State $nexthop \gets N_{32}[idx32]$
		\EndIf		
		\State {return $nexthop$}
		\EndProcedure
		
		\State /*counts the number of $1$s in left-most $n$ bits of $X$*/
		\Procedure{bitcount}{$X, n$}		
		\State {return $POPCNT(((1ULL << n) - 1) \ \& \ X)$}
		\EndProcedure
		
	\end{algorithmic}
\end{algorithm}

Algorithm 1 shows the lookup process of SAIL\_U where population counting is used. It starts by initializing the $nexthop$ to the default route (Line $2$). It then extracts 16 bits from the LSB of the IP address. This will be used as the index to $N_{16}$ and $C_{16}$. If $N_{16}[i] > 0$, SAIL\_U will update the $nexthop$ (Line $5$-$6$). If $C_{16}$ contains a valid chunk ID for the IP address, then SAIL\_U will further calculate the index to $N_{24}$; otherwise it will return the $nexthop$ (Line $7$-$13$). SAIL\_U then checks if $N_{24}[i] > 0$; if yes, then it updates the $nexthop$ (line $14$-$15$). It now needs to check if there is a chunk in level $32$ for this IP address. It does so by checking the bitmap. Note that a chunk (in Listing 1) is divided into $4$ parts. SAIL\_U first finds the part and the offset inside the part for the IP address by a simple division and a modulo operation (Line $17-18$). \footnote{The modulo and division operations can be replaced by bitwise operations} Note that although it may look very trivial, this approach allows us to use population counting while processing $8$ bits (instead of $6$ bits) in every step of the way. More ever, this approach can further be extended to where FIB lookup can process more than $8$ bits in every step of the way. For instance, if we want to develop a FIB lookup that processes $12$ bits in every step of the way, we can do so by maintaining a $4096$-bit bitmap and dividing the bitmap into $64$ parts. Such approach would be beneficial for lookup in IPv6 FIB where each prefix can be up to $128$ bit long. Line $19-20$ gets the bitmap and the start index for the IP address. Line $21$ checks if there is a chunk for this IP address in level $32$; if yes, it then calculates the index to $C_{24}$ (Line $23$). Note that it uses POPCNT instruction \cite{warren2013hacker} to count the number of bits set to $1$. Most of the modern  $X86$ processor supports POPCNT instruction. This allows us to convert the bitmap to an offset. Finally it calculates the index to $N_{32}$ in Line $25$. It is noteworthy that SAIL\_U does not need to backtrack in order to find the longest-prefix match. It visits level $16$, $24$ and $32$ in order and updates $nexthop$ in each step. This is why, $nexthop$ will contain the next-hop corresponding to the longest matching prefix.

Note that population counting is also applicable to SAIL\_L in the similar manner. In the our implementation, we have used population counting in both SAIL\_U and SAIL\_L. Our FIB update mechanism also populate the $CK_{24}$ array properly so that it can be utilized by FIB lookup. The details of our FIB update mechanism would be found in our implementation.

\section{Implementation} 
We have implemented both SAIL\_U and SAIL\_L in Linux kernel. Our implementation contains $1195$ and $1300$ lines of $C$ code respectively. We have made the source code publicly available as Linux kernel patches. \footnote{https://github.com/tamimcse/kernel-patches/blob/master/sail-u.patch} \footnote{https://github.com/tamimcse/kernel-patches/blob/master/sail-l.patch} Our website\footnote{\url{https://web.cs.kent.edu/~mislam4/sail-in-linux-kernel.html}} also contains the instructions to include the patches into Linux kernel source code. These patches have been produced with Linux kernel $4.19.0$-$rc6+$. Our implementation uses population counting to reduce the size of $C_{24}$. It is noteworthy that in actual implementation, $N_{16}$, $N_{24}$ and $N_{32}$ contain next-hop indices instead of actual next-hops. This allows us to use just one byte to store the next-hop index instead of using an actual pointer which is $8$ bytes in a $64$-bit machine. Note that, this approach is only applicable when the router has up to $255$ ports. If a router has more than $255$ ports, it will take $2$ bytes represent each next-hop index.

It is also noteworthy that although we use \textit{level-pushing}, we still need to store the actual prefix length in order to support incremental update. This is why it maintains an array $P_{16}$ which stores the actual prefix length of each prefix in $N_{16}$. In the same way, it maintains array $P_{24}$  and $P_{32}$ which store actual prefix lengths corresponding to prefixes in $N_{24}$ and $N_{32}$ respectively. $P_{16}$, $P_{24}$ and $P_{32}$ are only used for route insertion and route deletion. They are not used in FIB lookup. The details of the route insertion and route deletion will be found in our implementation.

We have tested our implementation with several very large routing tables containing more than $700K$ routes. Here we have tested our implementation by looking up all possible $2^{32}$ IPv4 addresses.

\subsection{SAIL in a Programmable Pipeline} 
This section discusses the implementation of SAIL\_U and SAIL\_L for a programmable pipeline. The programmable pipeline works as the dataplane in a router. It is noteworthy that the dataplane is only responsible for performing the FIB lookup. FIB update will be performed by the control plane (Linux kernel in this case). The control plane is responsible for computing the SAIL arrays and update the corresponding data structures in the dataplane. The dataplane will simply perform the FIB lookup based on the arrays. 

We have developed both SAIL\_U and SAIL\_L based FIB lookup which contain $67$ and $70$ lines of Domino code respectively. We have made our implementation publicly available. \footnote{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-u.c} \footnote{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-l.c} Note that we use \textit{popcnt} intrinsic function which counts the number of bits set to $1$. This function needs to be supported by the underlying pipeline hardware. Here we use Domino's \textit{raw} \cite{sivaraman2016packet} atom to compile our programs. A Domino program compiled by Domino compiler is guaranteed to run at line rate. If a Domino program cannot run on a programmable pipeline, the compilation fails. Domino  compiler can compile our implementation. This is why, our implementations are guaranteed to run at line rate. 

\begin {table}[H]
\caption {Comparison between SAIL\_U and SAIL\_L in a Programmable Pipeline} \label{sailpipeline} 
\begin{center}
	\begin{tabular}{ | m{4cm} | m{1cm} | m{1cm} |}
		\hline  & SAIL\_U& SAIL\_L \\
		\hline Number of pipeline stages & $15$  & $32$ \\
		\hline Maximum \# of atoms/stage & $5$ & $6$ \\
		\hline Processing latency & $15$ ns& $32$ ns \\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\section{Comparison between SAIL\_U and SAIL\_L in a Programmable Pipeline} 
Currently there is no Domino based programmable pipeline hardware, to the best of our knowledge. Thus, it is impossible to do experimental evaluation at this point. Here we evaluate the performance of SAIL\_U and SAIL\_L using Domino compiler. Domino compiler compiles a Domino program and produces a programmable pipeline which would be able to run the Domino program at line rate. The output of our Domino program shows that SAIL\_U would be able to run on a $15$-stage pipeline where the maximum number of atoms-per-stage \cite{sivaraman2016packet} is $5$.  On the other hand, SAIL\_L requires a $32$-stage pipelines where the maximum number of atoms-per-stage is $6$. We also have made the pipelines publicly available. \footnote{https://raw.githubusercontent.com/tamimcse/domino-examples/master/pipeline-sail-u.png} \footnote{https://raw.githubusercontent.com/tamimcse/domino-examples/master/pipeline-sail-l.png} The pipelines show how SAIL\_U and SAIL\_L are executed in a programmable pipeline. The results indicate that SAIL\_U requires fewer pipeline stages (i.e. fewer hardware resources) compared to that of SAIL\_L.  

It is noteworthy that each stage of a pipeline processes one packet in each clock cycle. If each pipeline stage runs at $1$ GHz, then each pipeline stage takes $1$ ns to process each packet. As SAIL\_U requires a $15$-stage pipeline, the entire pipeline will require $15$ ns to perform each FIB lookup. In the same way, SAIL\_L will require $32$ ns to perform each FIB lookup (due to $32$-stage pipeline). This is why, although SAIL\_L performs better than SAIL\_U in FIB lookup on a general purpose processor, SAIL\_U based FIB lookup outperforms SAIL\_L in a programmable pipeline. 

Table \ref{sailpipeline} summarizes the comparison between SAIL\_U and SAIL\_L in a programmable pipeline. Note that that although the pipelines of SAIL\_U and SAIL\_L require different number of stages, they both processes one packet in each clock cycle. Thus, both SAIL\_U and SAIL\_L can be implemented in a programmable pipeline at line rate.

\begin {table}[H]
\caption {FIB dataset} \label{fibdataset} 
\begin{center}
	\begin{tabular}{ | m{1cm} | m{1.5cm} | m{2cm} | m{2cm} |}
		\hline Name & AS Number& \# of prefixes & \# of next-hops\\
		\hline fib1 & $293$  & $759069$ & $2$ \\
		\hline fib2 & $852$ & $733378$ & $138$ \\
		\hline fib3 & $19016$ & $552285$ & $236$ \\
		\hline fib4 & $19151$ & $737125$ & $2$ \\
		\hline fib5 & $23367$  & $131336$ & $178$ \\
		\hline fib6 & $32709$ & $760195$ & $140$ \\
		\hline fib7 & $53828$ & $733192$ & $223$ \\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}


\section{EXPERIMENTAL RESULTS}
Currently Linux uses LC-trie for routing table lookup. However, the lookup performance of LC-trie is significantly slower than that of SAIL \cite{asai2015poptrie, yang2014guarantee}. This is why, this paper does not compare the performance of SAIL to that of LC-trie. It rather compares the performance of SAIL\_U to that of SAIL\_L. Here we evaluate the SAIL variants with FIBs of real backbone routers.

\subsection{Data Set}
We have obtained the FIBs of real backbone routers from Route Views projects \cite{routeviews}. The FIB snapshot has been taken on April. $1$, $2019$ at 10 PM EST. We have made the FIBs publicly available \footnote{https://github.com/tamimcse/parse-bgpdump/}. Table \ref{fibdataset} shows the description of the FIB tables. It is noteworthy that Route View project provides us with RIB (Routing Information Base). We then convert a RIB into a FIB (Forwarding Information Base) by keeping only one next-hop per prefix. Actual lookup is performed the on the FIB table. Here we have kept IPv4 prefixes only. Lookup in an IPv6 FIB table is beyond the scope of this paper. We also replace the next-hop indices by veth$0$-veth$31$. These veths (virtual ethernet in Linux kernel) act as the next-hops in our experiment. The Autonomous System (AS) number of Table \ref{fibdataset} represents the ISP of the corresponding FIB. For instance, the table shows that \textit{fib2} and \textit{fib6} belong to AS852 (TELUS Communications, an ISP in Canada) and AS32709 (Joink, an ISP in the US) respectively.   

\subsection{Experimental Setup}
The experiment has been conducted on a laptop running the our updated Linux kernel $4.19.0$-$rc6+$. The laptop however does not have many physical network interfaces needed to emulate a backbone router. Here we create $32$ virtual network interfaces (\textit{veth} kernel module) and use them as the next-hop of the routing table. The laptop has an Intel(R) Core (TM) i7-4510U processor (2GHz, $4$ MB L-$3$ cache) and 16 GB DRAM. The processor here has two physical cores (i.e. when the \textit{hyper-threading} is disabled). It is noteworthy that \textit{hyper-threading} results in unnecessary cache thrashing. This is why we disable hyper-threading before conducting the experiment.  We also disable \textit{frequency-scaling} of the CPU in order to get deterministic results.



\begin {table}[H]
\caption {Impact of population counting on memory consumption (for \textit{fib6})} \label{memory} 
\begin{center}
	\begin{tabular}{ | m{.9cm} | m{1.5cm} | m{1.5cm} | m{1.5cm} | m{1.5cm} |}
		\hline & \multicolumn{2}{|c|}{Without Population Counting} & \multicolumn{2}{|c|}{With Population Counting} \\
		\hline Array & Length & Size & Length & Size\\
		\hline $N_{16}$  & $65536$ & $64$ KB & $65536$ & $64$ KB\\
		\hline $C_{16}$ & $65536$ & $128$ KB & $65536$ & $128$ KB\\
		\hline $N_{24}$ & $6071808$ & $5.79$ MB & $6071808$ & $5.79$ MB\\
		\hline $CK_{24}$  &  & & $366$ & $22.87$ KB\\
		\hline $C_{24}$ & $6071808$ & $23.16$ MB & $366$ & $1.42$ KB\\
		\hline $N_{32}$ & $93696$ & $91.50$ KB & $93696$ & $91.50$ KB\\
		\hline Total &  & $29.22$ MB &  & $6.09$ MB\\		
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{memory}
	\caption{Memory consumption for different FIBs}\label{memorycomp}
\end{figure}

\subsection{Memory Consumption} 
Table \ref{memory} shows the impact of population counting on memory consumption. Here we show the memory consumption for \textit{fib6}.  Note that, the memory consumption primarily differs for $C_{24}$. The size of $C_{24}$ was $23.16$ MB before population counting was applied whereas the size is only $1.42$ KB after population counting is applied. The reason for this is as follows. Most of the prefixes in \textit{fib6} are with length $0-24$. It has found that more than $98.5\%$ routes in backbone routers are $0-24$ bit long \cite{bgpreport}. There are very few routes with length $25\sim32$ in a backbone routers. This is because a backbone router is very less likely to have a direct link to an end host. As a result, very few chunks will be needed in level $32$. As a result, most of the entries in $C_{24}$ remains zero. Population counting eliminates all the zero entries in $C_{24}$ by having an additional $CK_{24}$. This reduces the memory consumption significantly. 

Figure \ref{memorycomp} shows the memory consumptions for the FIBs of our data set. It shows that population counting reduces the memory consumption significantly for some FIBs (\textit{e.g. fib3, fib4, fib6}). However, if all the prefixes in a FIB are with length $0-24$, SAIL does not populate $C_{24}$. SAIL does not consume very large memory in that case. Population counting also has no effect on memory consumption in that case (e.g. \textit{fib1, fib2, fib5, fib7}).

\begin{figure}[!t]
	\begin{subfigure}[t]{0.25\textwidth}
		\centering
		\includegraphics[width=4.5cm]{candlesticks-sailbm.png}
		\caption{SAIL\_U}\label{sailbm-lookup}
	\end{subfigure}%
	~ 
	\begin{subfigure}[t]{0.25\textwidth}
		\centering
		\includegraphics[width=4.5cm]{candlesticks-saill.png}
		\caption{SAIL\_L}\label{saill-lookup}
	\end{subfigure}%
	\caption{Lookup cost for different levels .}\label{cpuvsplen}
\end{figure}

\subsection{Lookup Cost}
We measure the lookup cost based on the number of CPU cycles needed per lookup. It is noteworthy that measuring the cycle count accurately is not straightforward. We measure the cycle count using RDTSC instruction \cite{x86instructions}. But a CPU often reorders the instructions which lead to inaccurate cycle count. To prevent this problem, we also use RDTSCP and CPUID  instructions to serialize the instructions. We also disable the interrupts and preemption while measuring the cycle count. Finally we need to deduct the cost of RDTSC instruction itself to get the accurate cycle count of our routing table lookup. We run a tight loop to perform the routing table lookup to ensure that the cache populated. We also disable hyper-threading and CPU frequency scaling in order to avoid cache thrashing. We have made our test code publicly available as a Linux kernel patch. \footnote{https://github.com/tamimcse/kernel-patches/blob/master/test-fib-lookup.patch} It shows how to count the number of CPU cycles accurately for each FIB lookup.

The lookup cost of an IP address primarily depends on the level in which the longest matching prefix is found. The lookup cost should be the smallest if the longest prefix is found in level $16$. Again the lookup cost should be the highest if the longest prefix is found in level $32$. Figure \ref{cpuvsplen} shows the lookup cost of SAIL\_U and SAIL\_L for different levels. Here we only considered the cases where both SAIL\_U and SAIL\_L found the longest prefix in the CPU cache. We intentionally discarded the results when FIB lookup needed to access the DRAM. We have done this so that the DRAM latency does not affect the actual cost of the algorithms. The Figure \ref{cpuvsplen} shows that a general purpose processor cannot achieve deterministic performance. The actual cycle count of a program can vary even though the program is operating on the CPU cache. Note that SAIL\_L perform slightly better than SAIL\_U when the longest prefix is found in level $16$ or level $24$. This is because SAIL\_U requires one more lookup than SAIL\_L in that case. If SAIL\_L find a prefix in $N_{16}$ or $N_{24}$, it immediately knows that it is the longest prefix. On the other hand, SAIL\_U needs to check $C_{16}$ or $C_{24}$ to determine if there is a longer prefix.  However, as both $C_{16}$ and $C_{24}$ resides in the CPU cache, this cost is very minimal. 

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{update}
	\caption{Update cost for different prefix lengths}\label{update}
\end{figure}

\subsection{Update Cost}
Figure \ref{update} shows the average number of CPU cycles needed for FIB update for different prefix lengths. The figure shows that SAIL\_U performs significantly better than SAIL\_L for the prefixes with length $0-16$. SAIL\_U pushes the prefixes to level $16$ whereas SAIL\_L pushes the prefixes to either level $16$, $24$ or $32$. This is why SAIL\_L may need to update many more nodes compared to that of SAIL\_U which increases the update cost. Again SAIL\_U pushes the prefixes with length $17-24$ to level $24$ whereas SAIL\_L pushes them to either level $24$ or $32$. Thus, SAIL\_U performs similarly or better than SAIL\_L. A backbone router generally contain very few prefixes in level $32$. This is why, most of the prefixes with length $17-24$ are pushed to level $24$ (instead of level $32$) in SAIL\_L. As a result, both SAIL\_U and SAIL\_L perform very similarly in most of the cases. However, if a prefix with length $17-24$ is pushed to level $32$, it increases the update cost significantly which increases the average update cost. Finally Figure \ref{update} shows that both SAIL\_U and SAIL\_L performs very similarly for the prefixes with length $25-32$.

\section{Conclusion}
This paper presents an implementation of SAIL (both SAIL\_U and SAIL\_L) in Linux kernel and in a programmable pipeline. This is the first implementation of SAIL in those platforms. We use \textit{population counting} to reduce the memory consumption of SAIL. Our experimental results show that it can save the memory consumption by up to $80\%$. Our implementation shows that SAIL can be implemented in a programmable pipeline at line rate. It also shows that although SAIL\_L performs faster FIB lookup compared to SAIL\_U in a general purpose processor, SAIL\_U outperforms SAIL\_L in a programmable pipeline. We have used Domino programming language to develop SAIL for programmable pipelines. However, currently there is no hardware that supports Domino. This is why, we have restricted our experimental evaluation to SAIL in Linux kernel. We have evaluated it with FIBs from real backbone routers. Our experimental results show that our implementation can perform fast FIB lookup and update. It also shows that the FIB lookup in both SAIL\_U and SAIL\_L perform quite similarly on a general purpose processor. The FIB update of SAIL\_U however outperforms that of SAIL\_L in some cases. Overall it shows that our SAIL implementation can act as a dataplane and a control plane of a high-speed router.

\section*{Acknowledgment}

The authors would like to thank David Ahern (Cumulus Network) and Stephen Hemminger (Microsoft) for reviewing our Linux kernel patch and providing their valuable feedbacks. The authors would also like to thank the anonymous reviewers
for their valuable comments and suggestions to improve the quality of the paper.


\bibliographystyle{IEEEtran}
\bibliography{hotnets17}

\end{document}
